InputReader
Date: 2019-10-22

org.jmol.adapter.readers.simple

## Class InputReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.simple.InputReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader
  Direct Known Subclasses:
    MopacArchiveReader

      public class InputReader
      extends AtomSetCollectionReader

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `ac`
    `private java.util.Map<java.lang.String,java.lang.Integer>` | `atomMap`
    `private boolean` | `firstLine`
    `private boolean` | `isHeader`
    `private boolean` | `isJmolZformat`
    `private boolean` | `isMopac`
    `private javajs.util.Lst<java.lang.String[]>` | `lineBuffer`
    `private javajs.util.P4` | `plane1`
    `private javajs.util.P4` | `plane2`
    `private javajs.util.P3` | `pt0`
    `private java.util.Map<java.lang.String,java.lang.Float>` | `symbolicMap`
    `private java.lang.String[]` | `tokens`
    `private javajs.util.V3` | `v1`
    `private javajs.util.V3` | `v2`
    `protected javajs.util.Lst<Atom>` | `vAtoms`

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InputReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `checkLine()`
    `private java.lang.String` | `cleanLine()`
    `protected void` | `finalizeSubclassReader()` optional reader-specific method run first.
    `private Atom` | `getAtom()`
    `private Atom` | `getAtomGeneral(Atom atom, int ia, int bondOrder)`
    `private int` | `getAtomIndex(int i)`
    `private void` | `getSymbolic()`
    `private float` | `getSymbolic(java.lang.String key)`
    `private float` | `getValue(int i)`
    `private void` | `parseAtomTokens(Atom atom, java.lang.String element)`
    `private boolean` | `readBlock(java.lang.String strEnd)`
    `private void` | `readCFI()`
    `private void` | `readConFile()`
    `private boolean` | `readVFI()`
    `protected Atom` | `setAtom(Atom atom, int ia, int ib, int ic, float d, float theta1, float theta2)`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeReader, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ac

          protected int ac

    - #### vAtoms

          protected javajs.util.Lst<Atom> vAtoms

    - #### atomMap

          private java.util.Map<java.lang.String,java.lang.Integer> atomMap

    - #### tokens

          private java.lang.String[] tokens

    - #### isJmolZformat

          private boolean isJmolZformat

    - #### lineBuffer

          private javajs.util.Lst<java.lang.String[]> lineBuffer

    - #### symbolicMap

          private java.util.Map<java.lang.String,java.lang.Float> symbolicMap

    - #### isMopac

          private boolean isMopac

    - #### isHeader

          private boolean isHeader

    - #### firstLine

          private boolean firstLine

    - #### pt0

          private final javajs.util.P3 pt0

    - #### v1

          private final javajs.util.V3 v1

    - #### v2

          private final javajs.util.V3 v2

    - #### plane1

          private final javajs.util.P4 plane1

    - #### plane2

          private final javajs.util.P4 plane2

  - ### Constructor Detail

    - #### InputReader

          public InputReader()

  - ### Method Detail

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### readConFile

          private void readConFile()
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readCFI

          private void readCFI()
                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readVFI

          private boolean readVFI()
                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readBlock

          private boolean readBlock(java.lang.String strEnd)
                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### cleanLine

          private java.lang.String cleanLine()

    - #### finalizeSubclassReader

          protected void finalizeSubclassReader()
                                         throws java.lang.Exception

      Description copied from class: `AtomSetCollectionReader`
      optional reader-specific method run first.
      Overrides:
        `finalizeSubclassReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### getSymbolic

          private void getSymbolic()

    - #### getAtom

          private Atom getAtom()
                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### parseAtomTokens

          private void parseAtomTokens(Atom atom,
                                       java.lang.String element)
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAtomGeneral

          private Atom getAtomGeneral(Atom atom,
                                      int ia,
                                      int bondOrder)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getSymbolic

          private float getSymbolic(java.lang.String key)

    - #### getValue

          private float getValue(int i)
                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAtomIndex

          private int getAtomIndex(int i)

    - #### setAtom

          protected Atom setAtom(Atom atom,
                                 int ia,
                                 int ib,
                                 int ic,
                                 float d,
                                 float theta1,
                                 float theta2)